#include <bits/stdc++.h>

using namespace std;

long long a[80000];
long long b[80000];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    long long t,n,m;

    cin >> t;

    while(t--)
    {
        bool z=false;
        long long mini=1000000000000000001,mo;

        cin >> n;
        cin >> m;

        for(int i=0; i<n; i++)
        {
            cin >> a[i];

            for(int j=0; j<i; j++)
            {
                long long d=abs(a[i]-a[j]);

                if(d<mini)
                {
                    mini=d;
                }
            }
        }

        for(int i=0; i<m; i++)
        {
            cin >> b[i];
        }

        for(long long i=mini; i>0; i--)
        {
            z=false;
            for(int j=0; !z && j<n; j++)
            {
                if(j==0)
                {
                    mo=a[j]%i;
                }
                if(a[j]%i!=mo)
                {
                    z=true;
                    break;
                }
            }
            for(int k=0; !z && k<m; k++)
            {
                if(b[k]%i==mo)
                {
                    z=true;
                    break;
                }
            }
            if(!z)
            {
                cout << 1 << endl;
                break;
            }
        }
        if(z)
        {
            cout << 0 << endl;
        }
    }

    return 0;
}